
#ifndef Debug_h
#define Debug_h

#include <iostream>
#include <stdio.h>
#include <fstream>
#include <ostream>

using namespace std;

class Debug
{
private:
    bool debug;
public:
    Debug()
    {
        debug = true;
    };

    void info(const char* msg)
    {
#ifdef DEBUG
        if (debug)
            cout << msg << endl;
#endif
    };

    void error(const char* msg)
    {
#ifdef DEBUG
        if (debug)
            cout << "ERROR: " << msg << endl;
#endif
    };

    Debug operator<<(const char* param)
    {
#ifdef DEBUG
        if (debug)
            cout << param;
#endif
        return (*this);
    };

    Debug operator<<(int param)
    {
#ifdef DEBUG
        if (debug)
            cout << param;
#endif
        return (*this);
    };
    Debug operator<<(double param)
    {
#ifdef DEBUG
        if (debug)
            cout << param;
#endif
        return (*this);
    };
    Debug operator<<(float param)
    {
#ifdef DEBUG
        if (debug)
            cout << param;
#endif
        return (*this);
    };
    Debug operator<<(short param)
    {
#ifdef DEBUG
        if (debug)
            cout << param;
#endif
        return (*this);
    };

    Debug operator<<(ostream& (*param)(ostream&))
    {
#ifdef DEBUG
        if (debug)
            cout << param;
#endif
        return (*this);
    };

    void stopDebugging()
    {
        debug = false;
    };

};
#endif