#ifdef __cplusplus
extern "C"
{
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "alloc.h"
#include "fftsg2d.h"
#include "fftsg.h"

#ifndef GE_CONSTANT

#define GE_CONSTANT
#define GE_HDR_SIZE 	39984
#define TRANS_POINTS 	24
#endif

#ifndef DTI_STRUCT
#define DTI_STRUCT
    struct dtiP
    {
        short int nDims;
        short int dx;
        short int dy;
        short int dz;
        short int dt;
        short int dw;
        double Tacq;
        double FOVx;
        double FOVy;
        double FOVz;
        double dTE;
        double TE[128];
    };

#endif

    int writeFile_double(const char* filename, double *vec, int nDims, int *dims);
    int writeFile_double2text(const char *filename, double *vec, int nDims, int *dims, int flag);
    int writeFile_log(const char *filename, char *s, int flag);
    int readDifSchemFile(const char* filename, float difscheme[]);

    void PhaseUnWrap1D(double [], int);

    void LinearFit(double [], double [], int , double [], double []);

    void PhaseAngles(double *, double *, int , int , int , int);

    double dB1P(double [], double [], int);

    double *dB0Map(double *, double [], int , int , int , int);

    double lgr1d(double [], double [], int , double);

    void epiCorr(double [], double [], double , int , int , int);

    double otsu(double *, int , int , int , int, int , int , int);

    int findFirstGT(double *, int, double);

    int findLastGT(double *, int , double);

    double *eddygrad(double *, int , int , int);

    double *eddygrad_mask(double *, int , int , int , double *);

    void reconGradField(double *, double *, int , int , int);
    void reconEddyField(double* dB_dwi, double* CalibData, double difdir[], int dx, int dy, int dz);

    void dtiCorrFull(double *, double *, double *, double , int , int , int , int);
    void dtiCorrB0(double *, double *, double , int , int , int , int);

    double *magMask2(double *Mag, int dx, int dy, int dz, int dt);

    double* dti_correction(double *Dti, double *dB_base, double *Calib, struct dtiP P);

    double* dti_calibration(double *, struct dtiP);

    double* dti_calibration2(double *Phase, struct dtiP P, double *Mask);

    void CDFFT2_fftshift(double *im, int dx, int dy);

    void epcsi2d_conj(short *slice, struct dtiP P, double *ImComplex3d);

    void B2LInt16(short *s, int n);
    short * readGEPfile_int16B(const char* Pfilename, struct dtiP P);
    void phaserecon(short* vec, struct dtiP P, double * phase5d, double* mag5d);
    void flipDim2(double *mat, struct dtiP P);

    double* GE_Calibration(const char* filename, struct dtiP *Pout);

    int lsq(double a[], int m, int n, double b[], double x[]);

    int bmuav(double a[] , int m, int n, double u[], double v[], double eps, int ka);
    static void ppp(double a[], double e[], double s[], double v[], int m, int n);
    static void sss(double fg[2], double cs[2]);
    int bginv(double a[], int m, int n, double aa[], double eps, double u[], double v[], int ka);
    int agmiv(double a[], int m, int n, double b[], double x[], double aa[], double eps, double u[], double v[], int ka);

    double* dti_calibration3d(double* data, struct dtiP P, float difscheme[], double difAmp);
    double* dti_correction_3d(double *Dti, double *dB_base, double* CalibData, float dtiScheme[], struct dtiP P);

#ifdef __cplusplus
}
#endif