
#include "ui.h"

void DTICorrectUI::cb_Double_Window_i(Fl_Double_Window*, void*)
{
    window_close_callback();
}
void DTICorrectUI::cb_Double_Window(Fl_Double_Window* o, void* v)
{
    ((DTICorrectUI*)(o->user_data()))->cb_Double_Window_i(o, v);
}

void DTICorrectUI::cb_Browse_i(Fl_Button*, void*)
{
    getBoMapFile();
}
void DTICorrectUI::cb_Browse(Fl_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Browse_i(o, v);
}

void DTICorrectUI::cb_ECIF_Check_i(Fl_Check_Button*, void*)
{
    ECIF_Check_Box();
}
void DTICorrectUI::cb_ECIF_Check(Fl_Check_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->user_data()))->cb_ECIF_Check_i(o, v);
}

void DTICorrectUI::cb_ECIF_Browse_i(Fl_Button*, void*)
{
    getECIFFile();
}
void DTICorrectUI::cb_ECIF_Browse(Fl_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->user_data()))->cb_ECIF_Browse_i(o, v);
}

void DTICorrectUI::cb_Browse1_i(Fl_Button*, void*)
{
    getDTIFile();
}
void DTICorrectUI::cb_Browse1(Fl_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Browse1_i(o, v);
}

void DTICorrectUI::cb_Correct_i(Fl_Button*, void*)
{
    correctDTI();
}
void DTICorrectUI::cb_Correct(Fl_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->user_data()))->cb_Correct_i(o, v);
}

void DTICorrectUI::cb_DifSchemeFile_Browse_i(Fl_Button*, void*)
{
    getDifSchemeFile2();
}
void DTICorrectUI::cb_DifSchemeFile_Browse(Fl_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->user_data()))->cb_DifSchemeFile_Browse_i(o, v);
}

void DTICorrectUI::cb_Calibrate_i(Fl_Button*, void*)
{
    doCalibration();
}
void DTICorrectUI::cb_Calibrate(Fl_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->user_data()))->cb_Calibrate_i(o, v);
}

void DTICorrectUI::cb_GE_Button_i(Fl_Button*, void*)
{
    GE_Cal();
}
void DTICorrectUI::cb_GE_Button(Fl_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_GE_Button_i(o, v);
}

void DTICorrectUI::cb_Raw_Radio_i(Fl_Round_Button*, void*)
{
    cal_radio(1);
}
void DTICorrectUI::cb_Raw_Radio(Fl_Round_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Raw_Radio_i(o, v);
}

void DTICorrectUI::cb_Cal_Browse_i(Fl_Button*, void*)
{
    getCalFile();
}
void DTICorrectUI::cb_Cal_Browse(Fl_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Cal_Browse_i(o, v);
}

void DTICorrectUI::cb_Map_Radio_i(Fl_Round_Button*, void*)
{
    cal_radio(2);
}
void DTICorrectUI::cb_Map_Radio(Fl_Round_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Map_Radio_i(o, v);
}

void DTICorrectUI::cb_Orth_Browse_i(Fl_Button*, void*)
{
    getDifSchemeFile();
}
void DTICorrectUI::cb_Orth_Browse(Fl_Button* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Orth_Browse_i(o, v);
}

void DTICorrectUI::cb_Help_i(Fl_Menu_*, void*)
{
    help();
}
void DTICorrectUI::cb_Help(Fl_Menu_* o, void* v)
{
    ((DTICorrectUI*)(o->parent()->user_data()))->cb_Help_i(o, v);
}

Fl_Menu_Item DTICorrectUI::menu_[] = {
                                         {"Help", 0xffbe, (Fl_Callback*)DTICorrectUI::cb_Help, 0, 0, FL_NORMAL_LABEL, 0, 14, 0},
                                         {0, 0, 0, 0, 0, 0, 0, 0, 0}
                                     };

DTICorrectUI::DTICorrectUI()
{
    Fl_Double_Window* w;
    {
        Fl_Double_Window* o = Double_Window = new Fl_Double_Window(469, 599);
        w = o;
        o->callback((Fl_Callback*)cb_Double_Window, (void*)(this));
        {
            Fl_Tabs* o = new Fl_Tabs(10, 50, 450, 540, "DTI Geometric Distortion Correction");
            o->box(FL_PLASTIC_UP_BOX);
            {
                Fl_Group* o = new Fl_Group(10, 65, 450, 525, "Correct");
                o->box(FL_PLASTIC_UP_BOX);
                o->hide();
                {
                    Fl_Group* o = new Fl_Group(30, 220, 415, 105, "B0 Map");
                    o->box(FL_BORDER_FRAME);
                    o->color((Fl_Color)34);
                    o->align(FL_ALIGN_TOP_LEFT);
                    {
                        Fl_File_Input* o = B0_Map_File_Input = new Fl_File_Input(40, 230, 270, 30);
                        o->box(FL_PLASTIC_DOWN_BOX);
                        o->align(FL_ALIGN_TOP_LEFT);
                    }
                    {
                        Fl_Button* o = new Fl_Button(320, 230, 105, 30, "Browse");
                        o->box(FL_PLASTIC_UP_BOX);
                        o->callback((Fl_Callback*)cb_Browse);
                    }
                    {
                        Fl_Value_Input* o = B0_R_x = new Fl_Value_Input(55, 280, 25, 25, "x");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    {
                        Fl_Value_Input* o = B0_R_y = new Fl_Value_Input(103, 280, 25, 25, "y");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    {
                        Fl_Value_Input* o = B0_R_z = new Fl_Value_Input(151, 280, 25, 25, "z");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }

                    o->end();
                }
                {
                    Fl_Check_Button* o = ECIF_Check = new Fl_Check_Button(50, 353, 25, 25, "Use:");
                    o->down_box(FL_PLASTIC_DOWN_BOX);
                    o->callback((Fl_Callback*)cb_ECIF_Check);
                    o->align(FL_ALIGN_LEFT);
                    o->when(FL_WHEN_CHANGED);
                }
                {
                    Fl_File_Input* o = ECIF_Map_File_Input = new Fl_File_Input(75, 348, 285, 30, "Calibration File");
                    o->box(FL_PLASTIC_DOWN_BOX);
                    o->align(FL_ALIGN_TOP_LEFT);
                    o->deactivate();
                }
                {
                    Fl_Button* o = ECIF_Browse = new Fl_Button(365, 348, 85, 30, "Browse");
                    o->box(FL_PLASTIC_UP_BOX);
                    o->callback((Fl_Callback*)cb_ECIF_Browse);
                    o->deactivate();
                }
                {
                    Fl_Group* o = new Fl_Group(30, 95, 415, 105, "DTI Input");
                    o->box(FL_BORDER_FRAME);
                    o->color((Fl_Color)34);
                    o->align(FL_ALIGN_TOP_LEFT);
                    {
                        Fl_File_Input* o = DTI_File_Input = new Fl_File_Input(40, 105, 270, 30, "DTI");
                        o->box(FL_PLASTIC_DOWN_BOX);
                        o->labeltype(FL_NO_LABEL);
                    }
                    {
                        Fl_Button* o = new Fl_Button(320, 105, 105, 30, "Browse");
                        o->box(FL_PLASTIC_UP_BOX);
                        o->callback((Fl_Callback*)cb_Browse1);
                    }
                    {
                        Fl_Value_Input* o = DTI_x = new Fl_Value_Input(55, 155, 25, 25, "x");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    {
                        Fl_Value_Input* o = DTI_y = new Fl_Value_Input(103, 155, 25, 25, "y");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    {
                        Fl_Value_Input* o = DTI_z = new Fl_Value_Input(151, 155, 25, 25, "z");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    {
                        Fl_Value_Input* o = DTI_d = new Fl_Value_Input(200, 155, 25, 25, "w");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    o->end();
                }
                {
                    Fl_Button* o = new Fl_Button(160, 515, 145, 25, "Correct");
                    o->box(FL_PLASTIC_UP_BOX);
                    o->callback((Fl_Callback*)cb_Correct);
                }
                {
                    Fl_Value_Input* o = Time_Of_Acquisition = new Fl_Value_Input(315, 465, 85, 25, "Time of acquisition (in milliseconds)");
                    o->box(FL_PLASTIC_DOWN_BOX);
                    o->color((Fl_Color)55);
                }
                {
                    Fl_Output* o = DTI_Datatype = new Fl_Output(320, 155, 105, 25, "Data Type");
                    o->box(FL_PLASTIC_DOWN_BOX);
                    o->color(FL_BACKGROUND_COLOR);
                }
                {
                    Fl_Output* o = B0_R_Datatype = new Fl_Output(320, 280, 105, 25, "Data Type");
                    o->box(FL_PLASTIC_DOWN_BOX);
                    o->color(FL_BACKGROUND_COLOR);
                }
                {
                    Fl_File_Input* o = DifSchemeFileName = new Fl_File_Input(75, 400, 290, 30, "Diffusion Weighting Scheme");
                    o->box(FL_PLASTIC_DOWN_BOX);
                    o->align(FL_ALIGN_TOP_LEFT);
                    o->deactivate();
                }
                {
                    Fl_Button* o = DifSchemeFile_Browse = new Fl_Button(370, 400, 80, 30, "Browse");
                    o->box(FL_PLASTIC_UP_BOX);
                    o->callback((Fl_Callback*)cb_DifSchemeFile_Browse);
                    o->deactivate();
                }
                o->end();
            }
            {
                Fl_Group* o = new Fl_Group(10, 65, 450, 525, "Calibrate");
                o->box(FL_PLASTIC_UP_BOX);
                {
                    Fl_Button* o = Calibrate = new Fl_Button(185, 520, 85, 25, "Calibrate");
                    o->box(FL_PLASTIC_UP_BOX);
                    o->callback((Fl_Callback*)cb_Calibrate);
                }
                {
                    Fl_Group* o = new Fl_Group(30, 95, 415, 105, "Raw Phase Map File");
                    o->box(FL_BORDER_FRAME);
                    o->color((Fl_Color)33);
                    o->align(FL_ALIGN_TOP_LEFT);
                    {
                        Fl_Button* o = GE_Button = new Fl_Button(55, 115, 85, 25, "GE");
                        o->box(FL_PLASTIC_UP_BOX);
                        o->callback((Fl_Callback*)cb_GE_Button);
                        o->deactivate();
                    }
                    {
                        Fl_Button* o = Siemens_Button = new Fl_Button(195, 115, 85, 25, "Siemens");
                        o->box(FL_PLASTIC_UP_BOX);
                        o->deactivate();
                    }
                    {
                        Fl_Button* o = Phillips_Button = new Fl_Button(335, 115, 85, 25, "Phillips");
                        o->box(FL_PLASTIC_UP_BOX);
                        o->deactivate();
                    }
                    {
                        Fl_Round_Button* o = Raw_Radio = new Fl_Round_Button(30, 95, 25, 25);
                        o->down_box(FL_ROUND_DOWN_BOX);
                        o->selection_color((Fl_Color)6);
                        o->callback((Fl_Callback*)cb_Raw_Radio);
                    }
                    {
                        Fl_File_Input* o = Raw_Map_File_Input = new Fl_File_Input(55, 155, 365, 30);
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    o->end();
                }
                {
                    Fl_Group* o = new Fl_Group(30, 220, 415, 115, "B0 and DW Field Maps");
                    o->box(FL_BORDER_FRAME);
                    o->color((Fl_Color)33);
                    o->align(FL_ALIGN_TOP_LEFT);
                    {
                        Fl_File_Input* o = Cal_Map_File_Input = new Fl_File_Input(40, 245, 270, 30);
                        o->box(FL_PLASTIC_DOWN_BOX);
                        o->align(FL_ALIGN_TOP_LEFT);
                    }
                    {
                        Fl_Button* o = Cal_Browse = new Fl_Button(320, 245, 105, 30, "Browse");
                        o->box(FL_PLASTIC_UP_BOX);
                        o->callback((Fl_Callback*)cb_Cal_Browse);
                    }
                    {
                        Fl_Value_Input* o = Cal_R_x = new Fl_Value_Input(55, 295, 35, 25, "x");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    {
                        Fl_Value_Input* o = Cal_R_y = new Fl_Value_Input(103, 295, 32, 25, "y");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    {
                        Fl_Value_Input* o = Cal_R_z = new Fl_Value_Input(151, 295, 34, 25, "z");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    {
                        Fl_Value_Input* o = Cal_R_w = new Fl_Value_Input(205, 295, 35, 25, "w");
                        o->box(FL_PLASTIC_DOWN_BOX);
                    }
                    {
                        Fl_Output* o = Cal_R_Datatype = new Fl_Output(320, 295, 105, 25, "Data Type");
                        o->box(FL_PLASTIC_DOWN_BOX);
                        o->color(FL_BACKGROUND_COLOR);
                    }
                    {
                        Fl_Round_Button* o = Map_Radio = new Fl_Round_Button(30, 220, 25, 25);
                        o->down_box(FL_ROUND_DOWN_BOX);
                        o->selection_color((Fl_Color)6);
                        o->callback((Fl_Callback*)cb_Map_Radio);
                    }
                    o->end();
                }
                {
                    Fl_Group* o = new Fl_Group(30, 355, 415, 150, "ECIF Estimation with Orthogonal Base");
                    o->box(FL_BORDER_BOX);
                    o->align(FL_ALIGN_TOP_LEFT);
                    {
                        Fl_File_Input* o = Dif_Schem_FileName = new Fl_File_Input(42, 380, 273, 30);
                        o->box(FL_PLASTIC_DOWN_BOX);
                        o->deactivate();
                    }
                    {
                        Fl_Button* o = Orth_Browse = new Fl_Button(325, 380, 100, 30, "Browse");
                        o->box(FL_PLASTIC_UP_BOX);
                        o->callback((Fl_Callback*)cb_Orth_Browse);
                        o->deactivate();
                    }
                    {
                        Fl_Value_Input* o = DifGradAmplitude = new Fl_Value_Input(340, 430, 45, 25, "Diffusion Weighting Gradient Amplitude (G/cm)");
                        o->box(FL_PLASTIC_DOWN_BOX);
                        o->deactivate();
                        o->value(4);
                    }
                    o->end();
                }
                o->end();
            }
            o->end();
        }
        {
            Fl_Menu_Bar* o = new Fl_Menu_Bar(0, 0, 470, 25);
            o->menu(menu_);
        }
        o->end();
    }
    initialize_values();
}

void DTICorrectUI::getDTIFile()
{

    Fl_File_Chooser *fc = new Fl_File_Chooser(dir, NULL, 0, "DTI File");
    fc->filter("Header Files (*.hdr)\t");
    fc->preview(0);
    fc->show();
    while (fc->shown())
    {
        Fl::wait();
    }
	if (fc->value()==NULL)
	{
		return;
	}
    const char* filename = fc->value();
    dir = fc->directory();
    if (filename == NULL)
    {
        return;
    }
    DTI_File_Input->value(filename);

    dsr* header = readHeader(filename);
    if (header == NULL)
    {
        cout << "ERROR: File read error!";
        return;
    }

    char* datatype = "";
    switch (header->dime.datatype)
    {
    case DT_UNSIGNED_CHAR:
        datatype = "Char";
        break;
    case DT_DOUBLE:
        datatype = "Double";
        break;
    case DT_FLOAT:
        datatype = "Float";
        break;
    case DT_SIGNED_INT:
        datatype = "Integer";
        break;
    case DT_SIGNED_SHORT:
        datatype = "Short";
        break;
    default:
        datatype = "Unknown";
    }
    DTI_Datatype->value(datatype);

    int nDim = header->dime.dim[0];
    if (nDim >= 4)
    {
        DTI_x->value((double)header->dime.dim[1]);
        DTI_y->value((double)header->dime.dim[2]);
        DTI_z->value((double)header->dime.dim[3]);
        DTI_d->value((double)header->dime.dim[4]);
    }
}

void DTICorrectUI::getBoMapFile()
{

    Fl_File_Chooser *fc = new Fl_File_Chooser(dir, NULL, 0, "B0 Map Real File");
    fc->filter("Header Files (*.hdr)\t");
    fc->preview(0);
    fc->show();
    while (fc->shown())
    {
        Fl::wait();
    }
	if (fc->value()==NULL)
	{
		return;
	}
    dir = fc->directory();
    const char* filename = fc->value();
    if (filename == NULL)
    {
        return;
    }
    B0_Map_File_Input->value(filename);
    dsr* header = readHeader(filename);
    if (header == NULL)
    {
        cout << "ERROR: File read error!";
        return;
    }

    char* datatype = "";
    switch (header->dime.datatype)
    {
    case DT_UNSIGNED_CHAR:
        datatype = "Char";
        break;
    case DT_DOUBLE:
        datatype = "Double";
        break;
    case DT_FLOAT:
        datatype = "Float";
        break;
    case DT_SIGNED_INT:
        datatype = "Integer";
        break;
    case DT_SIGNED_SHORT:
        datatype = "Short";
        break;
    default:
        datatype = "Unknown";
    }
    B0_R_Datatype->value(datatype);

    int nDim = header->dime.dim[0];

    {
        B0_R_x->value((double)header->dime.dim[1]);
        B0_R_y->value((double)header->dime.dim[2]);
        B0_R_z->value((double)header->dime.dim[3]);

    }
}

void DTICorrectUI::getECIFFile()
{

    Fl_File_Chooser *fc = new Fl_File_Chooser(dir, NULL, 0, "ECIF Map File");
    fc->filter("Calibration Files (*.{calb,hdr})");
    fc->preview(0);
    fc->show();
    while (fc->shown())
    {
        Fl::wait();
    }
	if (fc->value()==NULL)
	{
		return;
	}
    dir = fc->directory();
    const char* filename = fc->value();
    if (filename == NULL)
    {
        return;
    }
    ECIF_Map_File_Input->value(filename);

    if (checkExtension(ECIF_Map_File_Input->value(), "*.hdr"))
    {
        DifSchemeFileName->activate();
        DifSchemeFile_Browse->activate();
    }
}

void DTICorrectUI::correctDTI()
{


    int dtiDims[8], B0_Dims[8], CalibDims[8], type;
    double FOV[3];

    int nDimDTI = readHeader(DTI_File_Input->value(), dtiDims, &type, DTI_imagename, FOV);
    if (nDimDTI == -1)
    {
        return;
    }

    DTI_imagename = getImageName(DTI_File_Input->value());
    double* DTIData = readFile(DTI_imagename, nDimDTI, dtiDims, type, (dtiDims[nDimDTI] == -1));
    if (DTIData == NULL)
    {
        cout << "ERROR: DTI file read error! \nData could not be loaded! Ending correction process..." << endl;
        return;
    }

    int nDimB0 = readHeader(B0_Map_File_Input->value(), B0_Dims, &type, B0_Map_imagename);
    if (nDimB0 == -1)
    {
        return;
    }
    B0_Map_imagename = getImageName(B0_Map_File_Input->value());
    double* B0_Data = readFile(B0_Map_imagename, nDimB0, B0_Dims, type, (B0_Dims[nDimB0] == -1));
    if (B0_Data == NULL)
    {
        cout << "ERROR: B0 map file read error! \nData could not be loaded! Ending correction process..." << endl;
        return;
    }


    dtiP P;
    P.dx = dtiDims[0];
    P.dy = dtiDims[1];
    P.dz = dtiDims[2];
    P.dt = B0_Dims[3];
    P.dw = dtiDims[3];
    P.Tacq = Time_Of_Acquisition->value();
    P.FOVx = FOV[0];
    P.FOVy = FOV[1];
    P.FOVz = FOV[2];


    double* Calib = NULL;
    char* Calib_imagename;
    if (ECIF_Check->value() != 0)
    {
        if (checkExtension(ECIF_Map_File_Input->value(), "*.hdr"))
        {
            int nDimCalib = readHeader(ECIF_Map_File_Input->value(), CalibDims, &type, Calib_imagename, FOV);
            if (nDimCalib == -1)
            {
                dti_correction(DTIData, B0_Data, NULL, P);
                return;
            }
            Calib_imagename = getImageName(ECIF_Map_File_Input->value());
            double* CalibData = readFile(Calib_imagename, nDimCalib, CalibDims, type, (CalibDims[nDimCalib] == -1));
            if (CalibData == NULL)
            {
                cout << "ERROR: Calib 3D file read error! \n No ECIF correction..." << endl;

                return;
            }

            int DW;
            float difscheme[150];
            double difAmp = 1;

            difAmp = DifGradAmplitude->value();

            DW = readDifSchemFile(DifSchemeFileName->value(), difscheme);

            for (int i = 0;i < 3*DW;++i)
            {
                difscheme[i] = difAmp * difscheme[i];
            }

           dti_correction_3d(DTIData, B0_Data, CalibData, difscheme, P);
        }
        else
        {
            Calib = readCalibFile(ECIF_Map_File_Input->value(), 4 * P.dz * (P.dw - 1));

            dti_correction(DTIData, B0_Data, Calib, P);
        }
    }
    else
    {
        Calib = NULL;
        dti_correction(DTIData, B0_Data, Calib, P);
    }

    dsr* header = readHeader(DTI_File_Input->value());
    header->dime.datatype = DT_DOUBLE;

    Fl_File_Chooser *fc = new Fl_File_Chooser(dir, NULL, Fl_File_Chooser::CREATE, "DTI File");
    fc->filter("Header Files (*.hdr)\t");
    fc->preview(0);
    fc->show();
    while (fc->shown())
    {
        Fl::wait();
    }
	if (fc->value()==NULL)
	{
		return;
	}
    dir = fc->directory();
    char* filename = new char[200];
    strcpy(filename, fc->value());
    if (filename == NULL)
    {
        return;
    }
    if (fl_filename_match(filename, "*.hdr") == 0)
    {
        strcat(filename, ".hdr");
    }

    if (writeHeader(filename, header) != 0)
    {
        cout << "ERROR: could not write output header file!" << endl;
    }
    if (writeImageFile(getImageName(filename), header, DTIData) != 0)
    {
        cout << "ERROR: could not write output image file!" << endl;
    }



    fl_message("Correction finished!");
}

void DTICorrectUI::show(int argc, char **argv)
{
    Double_Window->show(argc, argv);
    argc_ = argc;
    argv_ = argv;
}

void DTICorrectUI::getCalFile()
{

    Fl_File_Chooser *fc = new Fl_File_Chooser(dir, NULL, 0, "Real Data File");
    fc->filter("Header Files (*.hdr)\t");
    fc->preview(0);
    fc->show();
    while (fc->shown())
    {
        Fl::wait();
    }
	if (fc->value()==NULL)
	{
		return;
	}
    dir = fc->directory();
    const char* filename = fc->value();
    if (filename == NULL)
    {
        return;
    }
    Cal_Map_File_Input->value(filename);

    dsr* header = readHeader(filename);
    if (header == NULL)
    {
        cout << "ERROR: File read error!";
        return;
    }

    char* datatype = "";
    switch (header->dime.datatype)
    {
    case DT_UNSIGNED_CHAR:
        datatype = "Char";
        break;
    case DT_DOUBLE:
        datatype = "Double";
        break;
    case DT_FLOAT:
        datatype = "Float";
        break;
    case DT_SIGNED_INT:
        datatype = "Integer";
        break;
    case DT_SIGNED_SHORT:
        datatype = "Short";
        break;
    default:
        datatype = "Unknown";
    }
    Cal_R_Datatype->value(datatype);

    int nDim = header->dime.dim[0];
    if (nDim >= 4)
    {
        Cal_R_x->value((double)(header->dime.dim[1]));
        Cal_R_y->value((double)(header->dime.dim[2]));
        Cal_R_z->value((double)(header->dime.dim[3]));
        Cal_R_w->value((double)(header->dime.dim[4]));
    }

    Dif_Schem_FileName->activate();
    Orth_Browse->activate();
    DifGradAmplitude->activate();

}

void DTICorrectUI::doCalibration()
{


    const char* filename = Cal_Map_File_Input->value();
    if (strlen(filename) == 0)
    {
        cout << "ERROR: filename missing! Fill out fields completely!" << endl;
        return;
    }

    dsr* header = readHeader(filename);
    if (header == NULL)
    {
        cout << "ERROR: File read error!\nCould not open: " << filename << "\nCalibration stopped!" << endl;
        return;
    }


    double* data = readFile(getImageName(filename), header);
    if (data == NULL)
    {
        cout << "ERROR: Data file read error! \nData could not be loaded! Ending calibration process..." << endl;
        return;
    }

    dtiP P;
    P.dx = header->dime.dim[1];
    P.dy = header->dime.dim[2];
    P.dz = header->dime.dim[3];
    P.dw = header->dime.dim[4];
    P.FOVx = header->dime.pixdim[1] * header->dime.dim[1];
    P.FOVy = header->dime.pixdim[2] * header->dime.dim[2];
    P.FOVz = header->dime.pixdim[3] * header->dime.dim[3];


    const char* filenameDifScheme = Dif_Schem_FileName->value();

    if (strlen(filenameDifScheme) == 0)
    {

        double* calib = dti_calibration(data, P);

        Fl_File_Chooser *fc = new Fl_File_Chooser(dir, NULL, Fl_File_Chooser::CREATE, "Save Calibration File");
        fc->filter("Calibration Files (*.calb)\t");
        fc->preview(0);
        fc->show();
        while (fc->shown())
        {
            Fl::wait();
        }
		if (fc->value()==NULL)
		{
			return;
		}
        dir = fc->directory();

        char newFilename[200];
        strcpy(newFilename, fc->value());
        if (newFilename == NULL)
        {
            return;
        }

        if (fl_filename_match(newFilename, "*.calb") == 0)
        {
            strcat(newFilename, ".calb");
        }
        if (writeCalibFile(newFilename, 4*P.dz*(P.dw - 1), calib) != 0)
        {
            cout << "ERROR: Calibration file could not be written!" << endl;
        }

    }
    else
    {
        int DW;
        float difscheme[150];
        double difAmp;
        DW = readDifSchemFile(Dif_Schem_FileName->value(), difscheme);
        difAmp = DifGradAmplitude->value();
        if (difAmp < 0.000001)
        {
            fl_message("Warning: Keep the same diffusion \n weighting gradient amplitude.");
            difAmp = 1;
        }


        double* calib3d = dti_calibration3d(data, P, difscheme, difAmp);


        Fl_File_Chooser *fc = new Fl_File_Chooser(dir, NULL, Fl_File_Chooser::CREATE, "Save Calibration File");
        fc->filter("Header Files (*.hdr)\t");
        fc->preview(0);
        fc->show();
        while (fc->shown())
        {
            Fl::wait();
        }
		if (fc->value()==NULL)
		{
			return;
		}
        dir = fc->directory();
        if (strlen(fc->value()) == 0)
        {
            return;
        }

        char* filenameCalib3D = new char[200];
        strcpy(filenameCalib3D, fc->value());

        if (fl_filename_match(filenameCalib3D, "*.hdr") == 0)
        {
            strcat(filenameCalib3D, ".hdr");
        }

        header->dime.datatype = DT_DOUBLE;
        header->dime.dim[4] = 4;

        if (writeHeader(filenameCalib3D, header) != 0)
        {
            cout << "ERROR: could not write output header file!" << endl;
        }
        if (writeImageFile(getImageName(filenameCalib3D), header, calib3d) != 0)
        {
            cout << "ERROR: could not write output image file!" << endl;
        }

        free(calib3d);


    }

    fl_message("Calibration finished!");
}

void DTICorrectUI::ECIF_Check_Box()
{

    if (ECIF_Check->value() == 0)
    {
        ECIF_Map_File_Input->deactivate();
        ECIF_Browse->deactivate();
        DifSchemeFileName->deactivate();
        DifSchemeFile_Browse->deactivate();
    }
    else
    {
        ECIF_Map_File_Input->activate();
        ECIF_Browse->activate();
        if (strlen(ECIF_Map_File_Input->value()) > 0)
        {
            DifSchemeFileName->activate();
            DifSchemeFile_Browse->activate();
        }
    }
}

void DTICorrectUI::help()
{
    Fl_Help_Dialog hlp = Fl_Help_Dialog();
    hlp.load("help.html");
    hlp.show();
    while (hlp.visible())
    {
        Fl::wait();
    }
}

void DTICorrectUI::window_close_callback()
{

    ofstream initFile;
    initFile.open("b0mapcorrect.ini", ios::out | ios::trunc);
    initFile << "Tacq = ";
    if (Time_Of_Acquisition->value() != 0)
        initFile << Time_Of_Acquisition->value();
    else
        initFile << 44.0;
    initFile << endl << "Path =" << dir << "#" << endl;
    initFile << "DTI File =" << DTI_File_Input->value() << "#" << endl;
    initFile << "B0 File =" << B0_Map_File_Input->value() << "#" << endl;
    initFile << "ECIF File =" << ECIF_Map_File_Input->value() << "#" << endl;
    initFile << "Cal File =" << Cal_Map_File_Input->value() << "#" << endl;
    initFile.close();
    Double_Window->hide();
}

void DTICorrectUI::initialize_values()
{

    dir = new char[200];
    strcpy(dir, ".");
    ifstream initFile;
    initFile.open("b0mapcorrect.ini");
    Time_Of_Acquisition->value(44);
    if (!initFile.is_open())
    {
        return;
    }
    else
    {
        char dat = ' ';
        while (dat != '=' && !initFile.eof())
            initFile >> dat;
        if (initFile.eof())
        {
            return;
        }
        double val;
        initFile >> val;
        Time_Of_Acquisition->value(val);
        initFile >> dat;
        while (dat != '=' && !initFile.eof())
            initFile >> dat;
        if (initFile.eof())
        {
            return;
        }
        initFile.getline(dir, 200, '#');

        initFile >> dat;
        while (dat != '=' && !initFile.eof())
            initFile >> dat;
        if (initFile.eof())
        {
            return;
        }
        char* temp = new char[200];
        initFile.getline(temp, 200, '#');
        DTI_File_Input->value(temp);

        initFile >> dat;
        while (dat != '=' && !initFile.eof())
            initFile >> dat;
        if (initFile.eof())
        {
            return;
        }
        initFile.getline(temp, 200, '#');
        B0_Map_File_Input->value(temp);

        initFile >> dat;
        while (dat != '=' && !initFile.eof())
            initFile >> dat;
        if (initFile.eof())
        {
            return;
        }
        initFile.getline(temp, 200, '#');
        ECIF_Map_File_Input->value(temp);

        initFile >> dat;
        while (dat != '=' && !initFile.eof())
            initFile >> dat;
        if (initFile.eof())
        {
            return;
        }
        initFile.getline(temp, 200, '#');
        Cal_Map_File_Input->value(temp);

        delete temp;
    }
    initFile.close();
    Map_Radio->set();
}

void DTICorrectUI::cal_radio(int which_one)
{
    switch (which_one)
    {
    case 1:
        Cal_Map_File_Input->deactivate();
        Cal_R_x->deactivate();
        Cal_R_y->deactivate();
        Cal_R_z->deactivate();
        Cal_R_w->deactivate();
        Cal_Browse->deactivate();
        Cal_R_Datatype->deactivate();
        GE_Button->activate();
        Siemens_Button->activate();
        Phillips_Button->activate();
        Map_Radio->value(0);
        break;
    case 2:
        Cal_Map_File_Input->activate();
        Cal_R_x->activate();
        Cal_R_y->activate();
        Cal_R_z->activate();
        Cal_R_w->activate();
        Cal_Browse->activate();
        Cal_R_Datatype->activate();
        GE_Button->deactivate();
        Siemens_Button->deactivate();
        Phillips_Button->deactivate();
        Raw_Radio->value(0);
        break;
    }
}

void DTICorrectUI::GE_Cal()
{

    Fl_File_Chooser *fc = new Fl_File_Chooser(dir, NULL, 0, "GE P File");
    fc->filter("GE p Files (*.p)\t");
    fc->preview(0);
    fc->show();
    while (fc->shown())
    {
        Fl::wait();
    }
	if (fc->value()==NULL)
	{
		return;
	}
    dir = fc->directory();
    const char* filename = fc->value();
    if (filename == NULL)
    {
        return;
    }
    Raw_Map_File_Input->value(filename);
    dtiP P;
    double* data = GE_Calibration(filename, &P);

    Fl_File_Chooser *fc2 = new Fl_File_Chooser(dir, NULL, Fl_File_Chooser::CREATE, "DTI File");
    fc2->filter("Calibration Files (*.calb)\t");
    fc2->preview(0);
    fc2->show();
    while (fc2->shown())
    {
        Fl::wait();
    }
	if (fc2->value()==NULL)
	{
		return;
	}
    dir = fc2->directory();
    char* newFilename = new char[200];
    strcpy(newFilename, fc2->value());
    if (newFilename == NULL)
    {
        return;
    }
    if (fl_filename_match(newFilename, "*.calb") == 0)
    {
        strcat(newFilename, ".calb");
    }

    if (writeCalibFile(newFilename, 4*P.dz*(P.dw - 1), data) != 0)
    {
        cout << "ERROR: Calibration file could not be written!" << endl;
    }
}

void DTICorrectUI::getDifSchemeFile()
{

    Fl_File_Chooser *fc = new Fl_File_Chooser(dir, NULL, 0, "Diffusion Weighting Directional Scheme");
    fc->filter("Diffusion Directional Scheme Files (*.{grads,txt})");
    fc->preview(0);
    fc->show();
    while (fc->shown())
    {
        Fl::wait();
    }
	if (fc->value()==NULL)
	{
		return;
	}
    dir = fc->directory();
    const char* filename = fc->value();
    if (filename == NULL)
    {
        return;
    }
    Dif_Schem_FileName->value(filename);
}

void DTICorrectUI::getDifSchemeFile2()
{

    Fl_File_Chooser *fc = new Fl_File_Chooser(dir, NULL, 0, "Diffusion Weighting Directional Scheme");
    fc->filter("Diffusion Directional Scheme Files (*.{grads,txt})");
    fc->preview(0);
    fc->show();
    while (fc->shown())
    {
        Fl::wait();
    }
	if (fc->value()==NULL)
	{
		return;
	}
    dir = fc->directory();
    const char* filename = fc->value();
    if (filename == NULL)
    {
        return;
    }
    DifSchemeFileName->value(filename);
}