
#ifndef ui_h
#define ui_h
#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_File_Chooser.H>
#include "fileIO.h"
#include <iostream>
#include "dtic.h"
#include "alloc.h"
#include <FL/Fl_Tabs.H>
#include <stdio.h>
#include "dbh.h"
using namespace std;
#include "TEChooser.h"
#include <FL/Fl_Group.H>
#include <fstream>
#include <FL/fl_ask.H>
#include <FL/Fl_Help_Dialog.h>
#include <FL/filename.H>
#include <FL/Fl_File_Input.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Value_Input.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Round_Button.H>
#include <FL/Fl_Menu_Bar.H>

class DTICorrectUI
{
    char* DTI_imagename;
    char* B0_Map_imagename;
    char**argv_;
    int argc_;
    char* dir;
public:
    DTICorrectUI();
    Fl_Double_Window *Double_Window;
private:
    void cb_Double_Window_i(Fl_Double_Window*, void*);
    static void cb_Double_Window(Fl_Double_Window*, void*);
public:
    Fl_File_Input *B0_Map_File_Input;
private:
    void cb_Browse_i(Fl_Button*, void*);
    static void cb_Browse(Fl_Button*, void*);
public:
    Fl_Value_Input *B0_R_x;
    Fl_Value_Input *B0_R_y;
    Fl_Value_Input *B0_R_z;
    Fl_Value_Input *B0_R_t;
    Fl_Check_Button *ECIF_Check;
private:
    void cb_ECIF_Check_i(Fl_Check_Button*, void*);
    static void cb_ECIF_Check(Fl_Check_Button*, void*);
public:
    Fl_File_Input *ECIF_Map_File_Input;
    Fl_Button *ECIF_Browse;
private:
    void cb_ECIF_Browse_i(Fl_Button*, void*);
    static void cb_ECIF_Browse(Fl_Button*, void*);
public:
    Fl_File_Input *DTI_File_Input;
private:
    void cb_Browse1_i(Fl_Button*, void*);
    static void cb_Browse1(Fl_Button*, void*);
public:
    Fl_Value_Input *DTI_x;
    Fl_Value_Input *DTI_y;
    Fl_Value_Input *DTI_z;
    Fl_Value_Input *DTI_d;
private:
    void cb_Correct_i(Fl_Button*, void*);
    static void cb_Correct(Fl_Button*, void*);
public:
    Fl_Value_Input *Time_Of_Acquisition;
    Fl_Output *DTI_Datatype;
    Fl_Output *B0_R_Datatype;
    Fl_File_Input *DifSchemeFileName;
    Fl_Button *DifSchemeFile_Browse;
private:
    void cb_DifSchemeFile_Browse_i(Fl_Button*, void*);
    static void cb_DifSchemeFile_Browse(Fl_Button*, void*);
public:
    Fl_Button *Calibrate;
private:
    void cb_Calibrate_i(Fl_Button*, void*);
    static void cb_Calibrate(Fl_Button*, void*);
public:
    Fl_Button *GE_Button;
private:
    void cb_GE_Button_i(Fl_Button*, void*);
    static void cb_GE_Button(Fl_Button*, void*);
public:
    Fl_Button *Siemens_Button;
    Fl_Button *Phillips_Button;
    Fl_Round_Button *Raw_Radio;
private:
    void cb_Raw_Radio_i(Fl_Round_Button*, void*);
    static void cb_Raw_Radio(Fl_Round_Button*, void*);
public:
    Fl_File_Input *Raw_Map_File_Input;
    Fl_File_Input *Cal_Map_File_Input;
    Fl_Button *Cal_Browse;
private:
    void cb_Cal_Browse_i(Fl_Button*, void*);
    static void cb_Cal_Browse(Fl_Button*, void*);
public:
    Fl_Value_Input *Cal_R_x;
    Fl_Value_Input *Cal_R_y;
    Fl_Value_Input *Cal_R_z;
    Fl_Value_Input *Cal_R_w;
    Fl_Output *Cal_R_Datatype;
    Fl_Round_Button *Map_Radio;
private:
    void cb_Map_Radio_i(Fl_Round_Button*, void*);
    static void cb_Map_Radio(Fl_Round_Button*, void*);
public:
    Fl_File_Input *Dif_Schem_FileName;
    Fl_Button *Orth_Browse;
private:
    void cb_Orth_Browse_i(Fl_Button*, void*);
    static void cb_Orth_Browse(Fl_Button*, void*);
public:
    Fl_Value_Input *DifGradAmplitude;
    static Fl_Menu_Item menu_[];
private:
    void cb_Help_i(Fl_Menu_*, void*);
    static void cb_Help(Fl_Menu_*, void*);
public:
    void getDTIFile();
    void getBoMapFile();
    void getECIFFile();
    void correctDTI();
    void show(int argc, char **argv);
    void getCalFile();
    void doCalibration();
    void ECIF_Check_Box();
    void help();
    void window_close_callback();
    void initialize_values();
    void cal_radio(int which_one);
    void GE_Cal();
    void getDifSchemeFile();
    void getDifSchemeFile2();
};
#endif